
//*************************************************************************
// Atmega32: 32-Kanal-Lauflicht (32-channel-sequencer) 
//
// Steffen Mller wrote this file for 
// http://www.mikrocontrollerspielwiese.de 
//
// license: GPL (http://www.gnu.org/licenses/gpl.txt)
//
// have fun!
//*************************************************************************


	// Im Auslieferungszustand sind einige Anschlsse des PORTC
	// fr uns nicht benutzbar! Wir mssen das auf diesen Pins 
	// liegende JTAG-Interface deaktivieren, um PORTC vollstndig 
	// benutzen zu knnen. Siehe Makefile (make help)!
	

#include <avr/io.h>

#define F_CPU 1000000UL  // 1 MHz
#include <util/delay.h>


int main(void){
	
	//Ausgnge festlegen
	DDRA = 255; 
	DDRB = 255; 
	DDRC = 255;
	DDRD = 255; 
	
	//Leuchtzeit einer LED festlegen
	int t=100;
	
	while(1){
		
		// Die seltsame Reihenfolge ergab sich, weil ich meine LEDs 
		// auf einem Steckbrett rings um den Atmega32 plaziert hatte.
		// So lief der Leuchtpunkt im Uhrzeigersinn herum.
		PORTA |= _BV(PA0); _delay_ms(t); PORTA &= ~_BV(PA0);
		PORTA |= _BV(PA1); _delay_ms(t); PORTA &= ~_BV(PA1);
		PORTA |= _BV(PA2); _delay_ms(t); PORTA &= ~_BV(PA2);
		PORTA |= _BV(PA3); _delay_ms(t); PORTA &= ~_BV(PA3);
		PORTA |= _BV(PA4); _delay_ms(t); PORTA &= ~_BV(PA4);
		PORTA |= _BV(PA5); _delay_ms(t); PORTA &= ~_BV(PA5);
		PORTA |= _BV(PA6); _delay_ms(t); PORTA &= ~_BV(PA6);
		PORTA |= _BV(PA7); _delay_ms(t); PORTA &= ~_BV(PA7);
		
		PORTC |= _BV(PC7); _delay_ms(t); PORTC &= ~_BV(PC7);
		PORTC |= _BV(PC6); _delay_ms(t); PORTC &= ~_BV(PC6);
		PORTC |= _BV(PC5); _delay_ms(t); PORTC &= ~_BV(PC5);
		PORTC |= _BV(PC4); _delay_ms(t); PORTC &= ~_BV(PC4);
		PORTC |= _BV(PC3); _delay_ms(t); PORTC &= ~_BV(PC3);
		PORTC |= _BV(PC2); _delay_ms(t); PORTC &= ~_BV(PC2);
		PORTC |= _BV(PC1); _delay_ms(t); PORTC &= ~_BV(PC1);
		PORTC |= _BV(PC0); _delay_ms(t); PORTC &= ~_BV(PC0);
		
		PORTD |= _BV(PD7); _delay_ms(t); PORTD &= ~_BV(PD7);
		PORTD |= _BV(PD6); _delay_ms(t); PORTD &= ~_BV(PD6);
		PORTD |= _BV(PD5); _delay_ms(t); PORTD &= ~_BV(PD5);
		PORTD |= _BV(PD4); _delay_ms(t); PORTD &= ~_BV(PD4);
		PORTD |= _BV(PD3); _delay_ms(t); PORTD &= ~_BV(PD3);
		PORTD |= _BV(PD2); _delay_ms(t); PORTD &= ~_BV(PD2);
		PORTD |= _BV(PD1); _delay_ms(t); PORTD &= ~_BV(PD1);
		PORTD |= _BV(PD0); _delay_ms(t); PORTD &= ~_BV(PD0);
		
		PORTB |= _BV(PB7); _delay_ms(t); PORTB &= ~_BV(PB7);
		PORTB |= _BV(PB6); _delay_ms(t); PORTB &= ~_BV(PB6);
		PORTB |= _BV(PB5); _delay_ms(t); PORTB &= ~_BV(PB5);
		PORTB |= _BV(PB4); _delay_ms(t); PORTB &= ~_BV(PB4);
		PORTB |= _BV(PB3); _delay_ms(t); PORTB &= ~_BV(PB3);
		PORTB |= _BV(PB2); _delay_ms(t); PORTB &= ~_BV(PB2);
		PORTB |= _BV(PB1); _delay_ms(t); PORTB &= ~_BV(PB1);
		PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);
	
	}
 
	return 0;
}



		
		

		
		

